<?php
// Own namespace
namespace CoreFramework\Menu;

// Import framework stuff
use CoreFramework\Generic\FrameworkInterface;
use CoreFramework\Template\CompileableTemplate;

/**
 * An interface for renderable menus
 *
 * @author		Roland Haeder <webmaster@shipsimu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007 - 2009 Roland Haeder, this is free software
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.shipsimu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
interface RenderableMenu extends FrameworkInterface {
	/**
	 * Renders the menu by loading the base template and a menu-specific
	 * template.
	 *
	 * @return	void
	 */
	function renderMenu ();

	/**
	 * Transfers the rendered menu to a given template engine by assigning
	 * the rendered content with a template variable.
	 *
	 * @2param	$templateInstance	An instance of a CompileableTemplate class
	 * @return	void
	 */
	function transferContentToTemplateEngine (CompileableTemplate $templateInstance);

}
