<?php
// Own namespace
namespace CoreFramework\Resolver\Command;

// Import framework stuff
use CoreFramework\Request\Requestable;

/**
 * An instance for command resolver classes
 *
 * @author		Roland Haeder <webmaster@shipsimu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009 - 2017 Core Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.shipsimu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
interface CommandResolver extends Resolver {
	/**
	 * Returns an command instance for a given request class
	 *
	 * @param	$requestInstance	An instance of a Requestable class
	 * @return	$commandInstance	An instance of the resolved command
	 */
	function resolveCommandByRequest (Requestable $requestInstance);

	/**
	 * Checks whether the given command is valid
	 *
	 * @param	$commandName	The default command we shall execute
	 * @return	$isValid		Whether the given command is valid
	 * @throws	EmptyVariableException	Thrown if given command is not set
	 */
	function isCommandValid ($commandName);

}
